( 3iArpeggiator.fs - AE -  Round 2:  2021-08-10---Tue---04:52 )
\ V3 - 2021-05-15---Sat---16:57 - Integrated with Arpeggitor on piano board with lights board and 8-key keyboard (not 4x4 matrix)
\ V4 - 2021-09-14---Tue---22:00 - build much simpler arpeggiator with arbitrary 64-bit pattern.
\ V5 - 2021-09-20---Mon---00:38 - content moved to 3iSound-4x4.fs and 3iSongList.fs, leaving examples here


\ Design: these arpeggios play over the notes of a scale
\ d minor harmonic scale
: dmH-scale 
begin 
    d_ note 
    e%_ note
    f#_ note
    g_ note
    a_ note
    b%_ note
    c#' note
    d' note
    c#' note
    b%_ note
    a_ note
    g_ note
    f#_ note
    e%_ note    
    key? 
until ;
    
: dmH-explore 
begin 
    d_ note 
    f#_ note
    e%_ note
    a_ note
    g_ note
    b%_ note
    c#' note
    d' note
    c#' note
    a_ note
    b%_ note
    g_ note
    e%_ note    
    f#_ note
    key? 
until ;
\ CODE REVIEW: create random music maker working on scales...

: dmH-explore-AE
begin 
    d_ note 
    e%_ note
    f#_ note
    g_ note
    >//
    g_ note
    a_ note
    g_ note
    f#_ note
    g_ note
    >// >//
    d_ note 
    e%_ note
    f#_ note
    g_ note
    >// 
    g_ note
    a_ note
    b%_ note
    c#' note
    b%_ note
    a_ note
    g_ note
    a__ note
    a__ note
    key? 
until key drop ;


\ ===========================

: help-arpeg
  cr
  cr ." HELP-ARPEG (arpeggiator)"
  cr ."    include 3iSongList.fs  3iArpeggiator.fs"
  cr ."    init-songs"
  cr
;

help-arpeg

\ VERSIONS
\ V1 - 
\ V2 - 2021-08-10---Tue---05:10 - cleaned up code, got working without 3iRecord.fs
\ V3 - 2021-08-20---Fri---06:07 - add note polling, for use with teaching songs in 3iSonglist.fs
\ V4 - 2021-09-19---Sun---16:05 - fixed sound of silence using arpeggiator core vocab now moved and developed more simply in 3iSongList.fs
\ TODO: add command to clear serial port in one command ...
